#include "cstring.h"

/******************************************************************************
 * liefert eine Zeiger auf das nchste Wort im String s
 * wurde kein Wort gefunden wird ein Zeiger auf Ende des Strings zurckgegeben
 *
 * -> s        - Zeiger auf String
 *****************************************************************************/
char * NextWord(char *s)
{
 while (*s && isSep(*s) )
    s++;

 return s;
}


/******************************************************************************
 * liefert die Lnge des Wortes, das an Pos s beginnt
 *
 * -> s        - Zeiger auf Wort (string)
 *****************************************************************************/
unsigned int WordLen(char *s)
{
 int  i=0;

 while (*s && !isSep(*s) )
      s++, i++;

 return i;
}


/******************************************************************************
 * liest das erste Wort aus s und speichert es in sword
 * 
 * -> s        - Zeiger auf String mit Wort
 * -> sword    - Nimmt das Wort auf
 *
 * Die Fkt. gibt Anzahl Zeichen des ersten Wortes zurck
 *****************************************************************************/
int cstring_word(char *s, char *sword)
{
 int  i=0;
 s = NextWord(s);

 while (*s && !isSep(*s) )
   {
      *sword = *s;
      s++, sword++;
      i++;
   }
 *(sword) = 0;
 return i;
}


/******************************************************************************
 * Wandelt einen String in Grobuchstaben und koderit mit ROT13
 * 
 * -> s        - Zeiger auf String
 *****************************************************************************/
void cstring_rot13(char *s)
{
 while (*s)
   {
      if (isBuchstabe(*s))
         {
            *s = toupper(*s); 
            *s += (*s >= 'N') ? -13 : +13;
         }
      s++;
   }
}


/******************************************************************************
 * Dreht einen String bis zur Lnge len um
 * 
 * -> s        - Zeiger auf String
 * -> len      - bis wohin soll umgedreht werden
 *****************************************************************************/
void cstring_reverse_to(char *s, unsigned int len)
{
 char          ch;
 unsigned int  i;
/* size_t        len = strlen(s); */

 for (i=0; i<len/2; i++)                  
   {
      ch          = s[i];                 
      s[i]        = s[len-1-i];           
      s[len-1-i]  = ch;                   
   }
}


/******************************************************************************
 * Dreht einen String um
 * 
 * -> s        - Zeiger auf String
 *****************************************************************************/
void cstring_reverse(char *s)
{
 cstring_reverse_to(s, strlen(s));
}


/******************************************************************************
 * Dreht einen String wortweise um
 * 
 * -> s        - Zeiger auf String
 *****************************************************************************/
void cstring_wdreverse(char *s)
{
 int i;
 while (s = NextWord(s), *s)
   {
      i = WordLen(s);
      cstring_reverse_to(s, i);
      s += i;
   }
}


/******************************************************************************
 * Wandelt einen String in Grobuchstaben
 * 
 * -> s        - Zeiger auf String
 *****************************************************************************/
void cstring_toupper(char *s)
{
 while(*s)
   {
     *s = toupper(*s); 
     s++;
   }
}


/******************************************************************************
 * Wandelt einen String in Kleinbuchstaben
 * 
 * -> s        - Zeiger auf String
 *****************************************************************************/
void cstring_tolower(char *s)
{
 while(*s)
   {
     *s = tolower(*s); 
     s++;
   }
}
