#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cstring.h"

void frees (char *s1,char *s2,char *s3)
{
	free(s1);
	free(s2);
	free(s3);
}

int teste(void)

{
	char *s1, *s2, *s3;
	int rueck,fehler= 1;


	s1= malloc(300 * sizeof(char));
	s2= malloc(300 * sizeof(char));
	s3= malloc(300 * sizeof(char));

/* Test fr Funktion cstring_word */
	printf("Test fr Funktion cstring_word\n");

	strcpy(s1,"\0");											/* 1 */
	strcpy(s3,s1);
	rueck= (cstring_word(s1,s2));
	if ((s2[0] != 0) ||(rueck != 0) || (strcmp(s3,s1) != 0)) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"\n \n\t");										/* 2 */
	strcpy(s3,s1);
	rueck= (cstring_word(s1,s2));
	if ((s2[0] != 0) || (rueck != 0) || (strcmp(s3,s1) != 0)) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"\n einwort");								/* 3 */
	strcpy(s3,s1);
	rueck= (cstring_word(s1,s2));
	if ((strcmp(s2,"einwort") != 0) ||(rueck != 7) || (strcmp(s3,s1) != 0)) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"\n zwei woerter\n\t");							/* 4 */
	strcpy(s3,s1);
	rueck= (cstring_word(s1,s2));
	if ((strcmp(s2,"zwei") != 0) || (rueck != 4) || (strcmp(s3,s1) != 0)) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"	Und noch ein Test!");							/* 5 */
	strcpy(s3,s1);
	rueck= (cstring_word(s1,s2));
	if ((strcmp(s2,"Und") != 0) || (rueck != 3) || (strcmp(s3,s1) != 0)) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"De\nm Test sein letzter!");						/* 6 */
	strcpy(s3,s1);
	rueck= (cstring_word(s1,s2));
	if ((strcmp(s2,"De") != 0) || (rueck != 2) || (strcmp(s3,s1) != 0)) { frees(s1,s2,s3); return fehler; }
	++fehler;

/* Test fr Funktion cstring_rot13 */

	printf("Test fr Funktion cstring_rot13\n");

	strcpy(s1,"\0");													/* 7 */
	cstring_rot13(s1);
	if (s1[0] != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"a");														/* 8 */
	cstring_rot13(s1);
	if (strcmp(s1,"N") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"1w12asdf2");												/* 9 */
	cstring_rot13(s1);
	if (strcmp(s1,"1J12NFQS2") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"Der ROBoTer iSt doff!!!");										/* 10 */
	cstring_rot13(s1);
	if (strcmp(s1,"QRE EBOBGRE VFG QBSS!!!") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"wER dOOf dOff sChREIbt, IsT sELBER dooF!?!!");							/* 11 */
	cstring_rot13(s1);
	if (strcmp(s1,"JRE QBBS QBSS FPUERVOG, VFG FRYORE QBBS!?!!") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"jRE qBBs qBss fPuERVog, VfG fRYORE qbbS!?!!");								/* 12 */
	cstring_rot13(s1);
	if (strcmp(s1,"WER DOOF DOFF SCHREIBT, IST SELBER DOOF!?!!") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

/* Test fr Funktion cstring_reverse */

	printf("Test fr Funktion cstring_reverse\n");

	strcpy(s1,"\0");											/* 13 */
	cstring_reverse(s1);
	if (s1[0] != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"w");												/* 14 */
	cstring_reverse(s1);
	if (strcmp(s1,"w") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"gerade");											/* 15 */
	cstring_reverse(s1);
	if (strcmp(s1,"edareg") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"   test");											/* 16 */
	cstring_reverse(s1);
	if (strcmp(s1,"tset   ") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"UNgrade");											/* 17 */
	cstring_reverse(s1);
	if (strcmp(s1,"edargNU") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"Dies ist ein Test!");								/* 18 */
    cstring_reverse(s1);
    if (strcmp(s1,"!tseT nie tsi seiD") != 0) { frees(s1,s2,s3); return fehler; }
    ++fehler;

	strcpy(s1,"Dies ist noch \n ein Test!");							/* 19 */
    cstring_reverse(s1);
	if (strcmp(s1,"!tseT nie \n hcon tsi seiD") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"DIeS iSt deR 287872. TEst!!!");									/* 20 */
    cstring_reverse(s1);
	if (strcmp(s1,"!!!tsET .278782 Red tSi SeID") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;



/* Test fr Funktion cstring_wdreverse */

	printf("Test fr Funktion cstring_wdreverse\n");

	strcpy(s1,"");														/* 21 */
    cstring_wdreverse(s1);
	if (strcmp(s1,"") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;
	
	strcpy(s1," ");														/* 22 */
    cstring_wdreverse(s1);
	if (strcmp(s1," ") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;


	strcpy(s1,"Dies ist ein Test!");									/* 23 */
    cstring_wdreverse(s1);
	if (strcmp(s1,"seiD tsi nie !tseT") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;
	
	strcpy(s1,"Dies  ist noch	 ein Test!");									/* 24 */
    cstring_wdreverse(s1);
	if (strcmp(s1,"seiD  tsi hcon	 nie !tseT") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;



/* Test fr Funktion cstring_toupper */

	printf("Test fr Funktion cstring_toupper\n");

	strcpy(s1,"\0");									/* 25 */
    cstring_toupper(s1);
	if (s1[0] != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"t");											/* 26 */
	cstring_toupper(s1);
	if (strcmp(s1,"T") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"ts");											/* 27 */
	cstring_toupper(s1);
	if (strcmp(s1,"TS") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;


	strcpy(s1,"DIeS iSt deR 287872. TEst!!!");									/* 28 */
    cstring_toupper(s1);
	if (strcmp(s1,"DIES IST DER 287872. TEST!!!") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;


/* Test fr Funktion cstring_tolower */

	printf("Test fr Funktion cstring_tolower\n");

	strcpy(s1,"\0");									/* 29 */
    cstring_tolower(s1);
	if (s1[0] != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"DIeS iSt deR 287872. TEst!!!");									/* 30 */
    cstring_tolower(s1);
	if (strcmp(s1,"dies ist der 287872. test!!!") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	strcpy(s1,"873 874hjkfHGH Jggghjg!");										/* 31 */
	cstring_tolower(s1);
	if (strcmp(s1,"873 874hjkfhgh jggghjg!") != 0) { frees(s1,s2,s3); return fehler; }
	++fehler;

	frees(s1,s2,s3);
	return 0;
}


void mytest(void)
{
 char s[256];
 char b[256];
 int i;

 /* --- TESTE cstring_word --- */
 strcpy(s,"");
 i = cstring_word(s,b);
 printf("1. s: '%s', b: '%s', i: '%d'\n", s, b, i);

 strcpy(s,"0");
 i = cstring_word(s,b);
 printf("2. s: '%s', b: '%s', i: '%d'\n", s, b, i);

 strcpy(s," \thallo");
 i = cstring_word(s,b);
 printf("3. s: '%s', b: '%s', i: '%d'\n", s, b, i);

 strcpy(s," \thallo \t ");
 i = cstring_word(s,b);
 printf("4. s: '%s', b: '%s', i: '%d'\n", s, b, i);

 strcpy(s,"hallo\t   \t");
 i = cstring_word(s,b);
 printf("5. s: '%s', b: '%s', i: '%d'\n\n", s, b, i);


 /* --- TESTE cstring_rot13 --- */
 strcpy(s,"a_HALLO_A z_welt_Z!");
 cstring_rot13(s);
 printf("1. s: '%s'\n", s);

 cstring_rot13(s);
 printf("2. s: '%s'\n", s);

 strcpy(s,"");
 cstring_rot13(s);
 printf("3. s: '%s'\n", s);

 strcpy(s,"  \t \n ");
 cstring_rot13(s);
 printf("4. s: '%s'\n", s);


 /* --- TESTE cstring_reverse --- */
 strcpy(s,"");
 cstring_reverse(s);
 printf("1. s: '%s'\n", s);

 strcpy(s,"Andreas Schibilla! \t");
 cstring_reverse(s);
 printf("2. s: '%s'\n", s);

 strcpy(s,"    \t");
 cstring_reverse(s);
 printf("3. s: '%s'\n", s);

 strcpy(s,"Hallo zwei  Spaces und \t Tab\n");
 cstring_reverse(s);
 printf("4. s: '%s'\n", s);

 strcpy(s,"Einmal falsch!");
 cstring_reverse(s);
 printf("5. s: '%s'\n", s);

 cstring_reverse(s);
 printf("6. s: '%s'\n", s);


 /* --- TESTE cstring_wdreverse --- */
 strcpy(s,"");
 cstring_wdreverse(s);
 printf("1. s: '%s'\n", s);

 strcpy(s," \t \t \t \n    ");
 cstring_wdreverse(s);
 printf("2. s: '%s'\n", s);

  strcpy(s,"Hallo Welt");
 cstring_wdreverse(s);
 printf("3. s: '%s'\n", s);

  strcpy(s,"   Andreas Schibilla\t\n");
 cstring_wdreverse(s);
 printf("4. s: '%s'\n", s);

  strcpy(s,"5");
 cstring_wdreverse(s);
 printf("5. s: '%s'\n", s);

  strcpy(s,"12345566777 und jetzt? ");
 cstring_wdreverse(s);
 printf("6. s: '%s'\n", s);

  strcpy(s,"    --->   ");
 cstring_wdreverse(s);
 printf("7. s: '%s'\n", s);


}


int main(void)
{
 int fehler;

  mytest();

	fehler= teste();
	if (fehler == 0) printf("Dem Test ihm sein erfolgreiches Ende!\n");
	else printf("Test fehlerhaft abgebrochen bei Test Nr. %d!\n",fehler);
	return 0;
}
